﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NotifyMail
{
    // アカウントの設定
    public class Account
    {
        public int RecvTime { get; set; } = 1;

        public string Mail { get; set; }
        public string Host { get; set; } = "imap.gmail.com";
        public int Port { get; set; } = 993;
        public string User { get; set; }
        public string Pass { get; set; }
        public bool SSL { get; set; } = true;

        public Account Clone()
            => (Account)MemberwiseClone();
    }

    // 環境設定(Singleton)
    class Config
    {
        // 唯一のインスタンス
        private static Config m_instance = null;
        // インスタンス取得
        public static Config getInstance()
        {
            if (m_instance == null)
                m_instance = new Config();
            return m_instance;
        }

        // コンストラクタ
        private Config()
        {
        }

        // アカウント設定
        public Account Account { get; set; } = new Account();

        // 設定のロード
        public void Load()
        {
            try
            {
                Account = new Account();
                var xml = new System.Xml.Serialization.XmlSerializer
                                (typeof(Account));
                var sr = new System.IO.StreamReader("config.cfg",
                                new System.Text.UTF8Encoding(false));
                Account ac;
                ac = (Account)xml.Deserialize(sr);
                sr.Close();
                Account = ac.Clone();
            }
            catch
            {
                Account = new Account();
            }
        }
        // 設定の保存
        public void Save()
        {
            try
            {
                var xml = new System.Xml.Serialization.XmlSerializer
                            (typeof(Account));
                var sw = new System.IO.StreamWriter("config.cfg", false,
                                new System.Text.UTF8Encoding(false));
                xml.Serialize(sw, Account);
                sw.Close();
            }
            catch
            {
            }
        }
    }
}
