﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace NotifyMail
{
    public partial class Form_Main : Form
    {
        public Form_Main()
        {
            InitializeComponent();

            // 起動時、非表示にする
            this.WindowState = FormWindowState.Minimized;
            this.ShowInTaskbar = false;
            this.Visible = false;
            this.FormBorderStyle = FormBorderStyle.FixedSingle;

            // タイマーの設定
            this.timer1.Interval = Config.getInstance().Account.RecvTime * 60 * 1000;
            this.timer1.Enabled = true;
        }

        /// <summary>
        /// 設定メニューハンドラ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tool_Setting_Click(object sender, EventArgs e)
        {
            var win = new Form_Config();
            if (win.ShowDialog() == DialogResult.OK)
                this.timer1.Interval = Config.getInstance().Account.RecvTime * 60 * 1000;
        }

        /// <summary>
        /// 終了メニューハンドラ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tool_Exit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private bool isDoTimer = false;
        /// <summary>
        /// タイマーハンドラ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void timer1_Tick(object sender, EventArgs e)
        {
            if (isDoTimer)
                return;
            isDoTimer = true;
            try
            {
                var mail = new RecvMail();
                mail.Host = Config.getInstance().Account.Host;
                mail.Port = Config.getInstance().Account.Port;
                mail.User = Config.getInstance().Account.User;
                mail.Pass = Config.getInstance().Account.Pass;
                mail.SSL = Config.getInstance().Account.SSL;

                // メール受信
                var list = mail.recvMail();
                if (list == null || list.Count == 0)
                    return;

                // 最新メール
                var m = list[list.Count - 1];
                // タイトル
                string subject = RecvMail.ConvertEncoding(
                                    m.SubjectEncoding,
                                    m.Subject);
                // 差出人
                string fromaddr = m.From.Address;
                // 送信日時
                DateTime recv_time = DateTime.Parse(m.Headers["Date"]);
                // 古いものは弾く
                if (recv_time <= DateTime.Now.AddMinutes(-Config.getInstance().Account.RecvTime))
                    return;

                // ポップアップを出す
                var win = new Form_Notify(fromaddr, recv_time, subject);
                win.Show();
            }
            catch
            {
            }
            isDoTimer = false;
        }
    }
}
