﻿using S22.Imap;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NotifyMail
{
    // メール受信
    class RecvMail
    {
        public string Host { get; set; } = "imap.gmail.com";
        public int Port { get; set; } = 993;
        public string User { get; set; }
        public string Pass { get; set; }
        public bool SSL { get; set; } = true;

        // 文字コード変換
        public static string ConvertEncoding(Encoding src_enc,
                                                string str)
        {
            try
            {
                Encoding src = src_enc;
                Encoding dst = Encoding.Unicode;
                byte[] tmp = src.GetBytes(str);
                byte[] tmp_str = Encoding.Convert(src, dst, tmp);
                string dst_str = dst.GetString(tmp_str);
                return dst_str;
            }
            catch
            {
                return "";
            }
        }

        // メール受信（未読のみ）
        public List<System.Net.Mail.MailMessage> recvMail()
        {
            var rtn = new List<System.Net.Mail.MailMessage>();
            try
            {
                using (ImapClient client =
                        new ImapClient(Host, Port, User, Pass, AuthMethod.Login, SSL))
                {
                    // 未読メールのみ取得
                    var uids = client.Search(
                        SearchCondition.Unseen());
                    // 受信
                    foreach (var uid in uids)
                    {
                        // 未読のまま受信
                        var msg = client.GetMessage(uid, false);
                        rtn.Add(msg);
                    }
                }
            }
            catch
            {
                rtn.Clear();
            }
            return rtn;
        }

    }
}
